#!/bin/sh
# $Id: inst.sh,v 1.1 1995/11/13 18:02:02 t_browr Exp $
#######################################################################
#	Copyright ( C ) 1995, Silicon Graphics, Inc.
# These coded instructions, statements, and computer programs  contain
# unpublished  proprietary  information of Silicon Graphics, Inc., and
# are protected by Federal copyright law.  They  may  not be disclosed
# to  third  parties  or copied or duplicated in any form, in whole or
# in part, without the prior written consent of Silicon Graphics, Inc.
#######################################################################
#
#	Screen Area install script for SGI
#	modified for IRIX 5.x
#	set verbose
#	expects to run in the same directory as the driver files, only.
#
#######################################################################
/bin/echo ""
/bin/echo "Begin AutoCAD Screen Area driver installation..."
/bin/echo ""
umask 000
#
#######################################################################
# Must have super-user privledges
#######################################################################
set `id`
if test "$1" != "uid=0(root)" ; then
	/bin/echo "You must have super-user privledges to run '$0'"
	/bin/echo "To do so, enter 'su' at the prompt the './$0'"
	/bin/echo ""
	exit 1
fi
#
#######################################################################
# Check for 5.x O/S
#######################################################################
case `/bin/uname -r` in
	6.*)
	/bin/echo "...IRIX `/bin/uname -r` is not supported with this package."
	/bin/echo "...use /opt/acad13/support/mole.6.2/inst.sh version instead."
	exit 2
	;;

	5.*)
	/bin/echo "...IRIX `/bin/uname -r` O/S detected."
	;;

	*)
	/bin/echo "*** Not supported on `/bin/uname -r` platform ***"
	exit 2
        ;;
esac
#
#######################################################################
#	Copy in new bmouse.o, loop.o
#######################################################################
if /bin/test -d /var/sysgen/boot ; then
	/bin/cp bmouse.o loop.o /var/sysgen/boot
else
	/bin/echo "System not running IRIX 5.x or greater."
	exit 2
fi
#
#######################################################################
#	Copy in headers for bmouse, loop
#######################################################################
/bin/cp bmouse loop /var/sysgen/master.d
#
GFILE="/var/sysgen/system/irix.sm"
istr="INCLUDE: loop bmouse"
str=`grep bmouse $GFILE`;
if test "$str" = "$istr" ; then
	echo "...looks like kernel drivers previously installed"
else
	/bin/echo "********************************************"	>> $GFILE
	/bin/echo "* Kernel drivers for AutoCAD R13 Screen Area"	>> $GFILE
	/bin/echo "********************************************"	>> $GFILE
	/bin/echo "$istr"						>> $GFILE
	fi
#
#######################################################################
#	Make the special device files for the pseudo-mouse.
#######################################################################
/bin/rm -f /dev/input/bmouse
/etc/mknod /dev/input/bmouse c 62 1
/bin/chmod +wr /dev/input/bmouse
/bin/rm -f /dev/input/mdev
/etc/mknod /dev/input/mdev c 62 0
/bin/chmod +wr /dev/input/mdev
#
#######################################################################
#	The doio program must be setuid root.
#	we place it by default in /etc/acad_mole which is probably 
#	mounted so the chmod, chown will work.
#######################################################################
if /bin/test -d /etc/acad_mole ; then
	/bin/echo "Directory: /etc/acad_mole already exists."
else
	/bin/mkdir -p /etc/acad_mole
fi
/bin/cp doio /etc/acad_mole/doio
/bin/chown root.sys /etc/acad_mole/doio
/bin/chmod u+sx,go+x,ugo-w /etc/acad_mole/doio
#
#######################################################################
#	Now tune the kernel to allow setuid() operation of doio
#######################################################################
GFILE="/var/sysgen/stune"
istr="nosuidshells = 0"
str=`grep nosuidshells $GFILE`;
if test "$str" = "$istr" ; then
        echo "...looks like kernel parameters previously set"
else
	/bin/echo "******************************************"	>> $GFILE
	/bin/echo "* Allow setuid for AutoCAD R13 Screen Area"	>> $GFILE
	/bin/echo "******************************************"	>> $GFILE
	/bin/echo "$istr"					>> $GFILE
fi
#
#######################################################################
#	Copy in X11 config file to use the pseudo-mouse
#######################################################################
if /bin/test -d /usr/lib/X11/input/config ; then
	/bin/echo "Directory: /usr/lib/X11/input/config already exists."
else
	/bin/mkdir -m 755 -p /usr/lib/X11/input/config >& /dev/null
fi
/bin/cp bogus_mo /usr/lib/X11/input/config/bogus_mouse
#
#######################################################################
#	Now (auto)config the kernel
#######################################################################
/bin/echo ""
/bin/echo "Automatically re-configuring the IRIX kernel for Screen Area."
/bin/echo "Please stand by..."
/etc/autoconfig
/bin/echo ""
/bin/echo "The AutoCAD Screen Area drivers have been successfully installed."
/bin/echo "You will now need to re-boot you system for the Screen Area drivers"
/bin/echo "you have just installed to be loaded.  After re-booting,"
/bin/echo "you can test the Screen Area drivers with the 'testit' program"
/bin/echo "located in this directory, as follows:"
/bin/echo "	> su"
/bin/echo "	# cd /opt/acad13/support/mole"
/bin/echo "	# ./testit"
/bin/echo ""
/bin/echo "Successful operation is indicated by the system cursor traversing"
/bin/echo "the screen, followed by a message."
/bin/echo ""
/bin/echo "You may also have to re-configure AutoCAD's digitizer driver to"
/bin/echo "enable Screen Area capabilities.  If you have not already configured"
/bin/echo "a digitizer table for AutoCAD, here's a helpful tip:"
/bin/echo ""
/bin/echo "    In the 'System Manager', be sure that the tablet's Serial Port"
/bin/echo "    is 'Available' in the 'Port Setup' tool.  If it is NOT available"
/bin/echo "    select the port and then 'Disconnect...' it."
/bin/echo ""
/bin/echo "    You should also ensure that AutoCAD has read/write access to "
/bin/echo "    the digitizer port.  Check this with:"
/bin/echo "        ls -l /dev/ttyd1"
/bin/echo "        - or -"
/bin/echo "        ls -l /dev/ttyd2"
/bin/echo ""
/bin/echo "    If you DO NOT see the following file permissions:"
/bin/echo "        crw-rw-rw- ... /dev/ttydX"
/bin/echo "        ^^^ ^^ ^^ Note: these items are required"
/bin/echo ""
/bin/echo "    Then correct them as follows:"
/bin/echo "        chmod +rw /dev/ttydX  (where X is 1 or 2 as required)"
/bin/echo ""
